#ifndef MEM_UTILS_H
#define MEM_UTILS_H

#include "aliases.h"
#include "platform.h"

#ifdef __cplusplus
BEGIN_C_LINKAGE
#endif // __cplusplus

#include "mem_utils_ops.h"

#if defined(WAPP_PLATFORM_WINDOWS)
#include "mem_utils_win.h"
#elif defined(WAPP_PLATFORM_POSIX)
#include "mem_utils_posix.h"
#else
#error "Unrecognised platform"
#endif

void *wapp_mem_util_align_forward(void *ptr, u64 alignment);
void *wapp_mem_util_alloc(void *addr, u64 size, MemAccess access, MemAllocFlags flags, MemInitType type);
void wapp_mem_util_free(void *ptr, u64 size);

external void *mem_util_allocate(void *addr, u64 size, MemAccess access, MemAllocFlags flags, MemInitType type);
external void mem_util_free(void *ptr, u64 size);

#ifdef __cplusplus
END_C_LINKAGE
#endif // __cplusplus

#endif // !MEM_UTILS_H
